public class PITCH_SAMPLE_PLAYER{
    PITCH_SAMPLER pSamp;
    
    SqrOsc s => LPF f => ADSR env => Gain g => dac;
    SinOsc bass => ADSR b_env => Gain b_g => dac;
    
    100 => s.freq;
    0.15 => g.gain;
    .3 => b_g.gain;
    900 => f.freq;
    3 => f.Q;
    env.keyOff();
    b_env.keyOff();
    
    env.set(.01, .1, .6, .1);
    
    fun void record(dur length){
        spork ~ pSamp.recordSomething(length);
        length => now;
    }
    
    [[ .9, 0.7, .4, .9, 
    .9, .1, .8, .1, 
    0.4, .3, .8, .6, 
    .6, .8, .9, .1 ],
    [ 0.1, 0.2, 1.0, .3, 
    0.5, .1, .7, .1, 
    1, .3, .2, .6, 
    .5, .8, .2, .8 ],
    [ .2, 0.8, .4, .9, 
    .9, .8, .1, .9, 
    .8, .3, .9, .6, 
    .9, .6, .7, .1 ]] @=> float pattern[][];
    
    0 => int patternSelect;
    
    0 => int i;
    0.0 => float density;
    Envelope densityEnv => blackhole;
    density => densityEnv.value;
    
    fun void LFODensity(){
        while(1){
            .5 + .5 * Math.sin( now/second * 1) => density;
            10::ms => now;
        }
    }
    
    fun void rampDensity(float target, dur howLong){
        <<<"rampDensity">>>;
            howLong => densityEnv.duration;
            target => densityEnv.target;
            <<<densityEnv.target()>>>;
        while(densityEnv.value() != target){
            densityEnv.value() => density;
           // <<<densityEnv.value()>>>;
            10::ms => now;
        }
    }
    
    fun void listenDensity(){     
        <<<"pitch density listeing">>>;
        while(1){
            2.5 * RMS_TRACKER.rmsSum => density;
            20::ms => now;
        }
    }
        
    fun void filterLFO(){
        while(1){
            900 + 200 * Math.sin( now/second * .5) => f.freq;
            10::ms => now;
        }
    }
    
    //spork ~dense();
    pSamp.setMode(0);
    
    fun void playSynth(int note){
        //<<< "note", note>>>;
        note => Std.mtof => s.freq;
        Std.rand2f(0.05, 0.2) => g.gain;
        env.keyOn();
        200::ms => now;
        env.keyOff();
    }
    
    fun void playBass(int note){
        <<< "slappin the bass", note>>>;
        note + 48 => Std.mtof => bass.freq;
        b_env.keyOn();
        2000::ms => now;
        b_env.keyOff();
    }
    
    
}

