// start TRANS_DETECT first
public class SAMPLER{
    // signal chain
    adc => Gain g => Envelope e => LiSa loop1 => dac;
    e => LiSa loop2 => dac;
    3 => g.gain;
    
    30::second => loop1.duration => loop2.duration;
    20::ms => dur fadetime;
    30::second => dur looplen;
    fadetime => e.duration;
    
    fun void playSomething(int num){  
        while (num > 0){
            <<< "playing something", num>>>;
            Std.rand2f(1,3)::second => now;
            // stop loop 2:
            loop1.play(0);
            // set playhead
            loop1.playPos(.5 *loop1.duration()-Std.rand2f(-9.0, 9)::second);
            // play
            Std.rand2f(.4, .8) => float rate;
            if (maybe)
                -rate => rate;
            loop1.rate(rate);
            loop1.play(1);
            Std.rand2f(3,5)::second => now;
            //stop
            
            // set playhead
            loop2.playPos(.5 *loop1.duration()-Std.rand2f(-9.0, 9)::second);
            // play
            Std.rand2f(.4, .9) => rate;
            if (maybe || maybe)
                -rate => rate;
            loop2.rate(rate);
            loop2.play(1);
            Std.rand2f(1,2)::second => now;
            // stop loop 1:
            loop1.play(0);

            Std.rand2f(3,5)::second => now;
            num--;
        }
    }
    
    fun void recordSomething(){
        // record
        <<< "recording" >>>;
        loop1.record(1);
        loop2.record(1);
        e.keyOn();
        now + (looplen - fadetime) => time later;
        
        while(now < later){
            10::ms => now;
        }
        e.keyOff();
        // stop!
        loop1.record(0);
        loop2.record(0);
    }
}

