// Pitch Estimation class
// shred this and look at static variable:
//
// ---  PITCH_ESTIMATE.freqEst  ---
//
// Depends on FFT_AUTO_CORR class

public class PITCH_ESTIMATE
{
    FFT_AUTO_CORR acor;
    acor.set_fft_size(1024);
    // the estimate
    static float freqEst; 
    // the threshold
    0.001 => static float threshold;
    
    fun void setThresh(float newThresh){
        newThresh => threshold;
    }
    
    10::ms => dur updateRate;
    fun void setUpdateRate(dur rate){
        rate => updateRate;
    }
    
    static float max;
    int max_index;
    40 => int min_lag;
    acor.size_over_two => int max_lag;
    
    fun void find_max_lag(){
        // zero out variables
        0.0 => max;
        0 => max_index;
        
        
        // loop through lags
        for (min_lag => int l; l < max_lag; l++){
            if (acor.acor_out[l] > max){
                l=>max_index;
                acor.acor_out[l] => max;
            }
            else if(-acor.acor_out[l] > max){
                l=> max_index;
                -acor.acor_out[l] => max;
            }
        }
    }
    
    fun void estimatePitch(){
        while(1){
            // calculate the auto correlation
            acor.calc_acor();
            find_max_lag();
            
            if (max > threshold){
                acor.srate/max_index => freqEst;
               // <<< "close enough, freq estimate: ", freqEst >>>;
            }
            
            updateRate => now;
        }
    }
}
0.0 => PITCH_ESTIMATE.max;
0 => PITCH_ESTIMATE.threshold;
0.0 => PITCH_ESTIMATE.freqEst;
PITCH_ESTIMATE estimator;
spork ~ estimator.estimatePitch();
while(1){
    1::day=> now;
}