public class ROLLOFF{
    // our patch
    adc => FFT fft =^ RollOff roff50 => blackhole;
    // a second rolloff
    fft =^ RollOff roff85 => blackhole;
    
    // set parameters
    1024 => fft.size;
    // set hann window
    Windowing.hann(1024) => fft.window;
    // compute srate
    second / samp => float srate;
    // set rolloff percents
    .5 => roff50.percent;
    .85 => roff85.percent;
    
    static float Roll50, Roll85;
    
    fun void calcRollOff(){
        // control loop
        while( true )
        {
            // upchuck: take fft then the rolloffs
            roff50.upchuck();
            roff85.upchuck();
            // print out
            //<<< "50% rolloff:", roff50.fval(0) * srate / 2,
            //"85% rolloff:", roff85.fval(0) * srate / 2 >>>;
            (roff50.fval(0) * srate / 2 ) => Roll50;
            (roff85.fval(0) * srate / 2 ) => Roll85;
            // advance time
            fft.size()::samp => now;
        }
    }
}

ROLLOFF rolly;
0.0 => ROLLOFF.Roll50 => ROLLOFF.Roll85;
spork ~ rolly.calcRollOff();
1::day=> now;
