// This FM patch estimates the fundamental and changes the freq after some time

SinOsc m => SinOsc c => LPF f => JCRev r => ADSR e => Gain g => dac;
2 => c.sync;
1000 => f.freq;
.1 => g.gain;
.01 => r.mix;
e.keyOff();
e.set(2::second, 1::second, .8, 2::second);

float carrier;

fun void changeModGain(){
    while(1){
        1000 * RMS_TRACKER.rmsSum => m.gain;
        
        //<<< RMS_TRACKER.rmsSum >>>;
        2000 - (500 * RMS_TRACKER.rmsSum ) => float newFreq;
        if (newFreq > 0)
            newFreq => f.freq;
        100::ms=> now;
    }
}
spork ~ changeModGain();

fun void updateFreq(){
    while(1){
        carrier + (5) * Math.sin( now/second * .1) => float freq;
        freq => c.freq; 
        10::ms=> now;
    }
}

spork~ updateFreq();

30 => int numEst;
int recentEst[numEst];
for (0 => int i; i < numEst; i++){
    0=> recentEst[i];
}
0 => int ptr;

fun int getRoot(){

    int p[12];

    for (0 => int i; i < numEst; i++){
        recentEst[i] => int note;
        p[note]++;
   }
    0 => int max;
    for(0 => int i; i < 12; i++){
        if (p[i] > max)
            i => max;
    }

    return max; 
}

fun void setRoot(int root){
    <<< "root :", root + 48 >>>;
    root + 48 => Std.mtof => carrier;
    e.keyOn();
    3::second=> now;

   e.keyOff(); 
}

fun void trackRoot(){

    while(1){
        
        if (TRANS_DETECT.yup && (PITCH_ESTIMATE.max > PITCH_ESTIMATE.threshold)){
            <<<"Hit">>>;
            10::ms  => now;
            500::ms + now => time later;
            while (now < later){
                if (PITCH_ESTIMATE.max > PITCH_ESTIMATE.threshold){
                    //<<< "in here">>>;
                    (PITCH_ESTIMATE.freqEst)$int => Std.ftom => float note;
                    //<<< "ptr", ptr, "note", Std.abs(note)%12>>>;
                    if (note < 0)
                        -note => note;
                    12 %=> note;
                    
                    note $int => recentEst[ptr];
                    ptr++;
                    numEst %=> ptr;
                    
                }
                1::ms => now;
            }
            <<< " setting">>>;
            setRoot(getRoot());
        }
        
      10::ms => now;   
    }

}
            
spork ~ trackRoot();

while(true)
{
    
    
    if (RMS_TRACKER.rmsSum > .03 && (e.state() == 3 || e.state() == 4) ){
        e.keyOn();
    }
    else if (RMS_TRACKER.rmsSum < .03)
    {
        e.keyOff();
    }
    
    10::ms => now;
    //    PITCH_ESTIMATE.freqEst => port1 => c.freq;
}
